<?php

declare(strict_types=1);

use yii;
use yii\bootstrap\ActiveForm;

use app\models\Account;
use app\models\Import;
use app\models\Settings;
use app\models\Warehouse;

use DateTime;
use DateTimeZone;

// Инициализация
$panel ?? $panel = 'profile_panel_supplies_input_import';

?>

<link href="/css/pages/profile.css" rel="stylesheet">

<div id="page_profile" class="container mb-auto">
    <div class="row h-100 py-3">
        <nav class="col-3">
            <?= $sidebar ?? yii::$app->controller->renderPartial('/profile/sidebar') ?>
        </nav>
        <article class="col-9">
            <div class="h-100 p-4 rounded">
                <div id="profile_panel_supplies" class="profile_panel">
                    <div class="profile_panel_menu mb-3">
                        <label class="btn button_white mb-0 mr-2" for="profile_panel_supplies_input_settings">Настройки</label>
                        <label class="btn button_white mb-0 mr-2" for="profile_panel_supplies_input_import">Склады</label>
                    </div>
                    <div class="profile_panel_content">

                        <input type="radio" id="profile_panel_supplies_input_settings" name="main_panel" <?= $panel === 'profile_panel_supplies_input_settings' ? 'checked' : null ?> />
                        <div class="col">
                            <p>В разработке</p>
                        </div>

                        <input type="radio" id="profile_panel_supplies_input_import" name="main_panel" <?= $panel === 'profile_panel_supplies_input_import' ? 'checked' : null ?> />
                        <div class="col">
                            <h5>Управление складами</h5>
                            <div class="dropdown-divider mb-4"></div>

                            <?php if (false && Account::isMinimalAuthorized()) : ?>
                                <?php
                                $form = ActiveForm::begin([
                                    'id' => 'form_product_import_excel',
                                    'action' => false,
                                    'fieldConfig' => [
                                        'template' => '{label}{input}',
                                        'options' => ['class' => '']
                                    ],
                                    'options' => [
                                        'class' => 'px-3 mb-3 d-flex',
                                        'onsubmit' => 'return false;'
                                    ]
                                ]);
                                ?>

                                <?= $form->field($supply, 'account', ['options' => ['class' => "ml-auto mb-4 pr-0 col-4 d-flex"]])->input('text', ['placeholder' => yii::$app->user->identity->_key])->label(options: ['class' => 'mr-2 my-auto font-weight-bold']); ?>
                                <?= $form->field($supply, 'file_excel', ['enableLabel' => false, 'options' => ['class' => 'mr-auto mb-4 pr-0 col-5 d-flex flex-column']])->fileInput(['class' => 'my-auto', 'multiple' => true, 'onChange' => 'page_profile_supplies_import_excel(this.parentElement.parentElement, this.parentElement.parentElement.getElementsByTagName(\'input\')[0].value, \'profile_panel_supplies_input_import\')']) ?>

                                <?php ActiveForm::end(); ?>
                                <?php
                                // Инициализация счетчика инстанций импорта
                                $amount = 0;

                                // Чтение истанций импорта
                                $imports = Import::read(limit: 100, order: ['desc']);

                                // Инициализация часового пояса
                                preg_match_all('/UTC([\+\-0-9:]*)/', $account->zone ?? Settings::searchActive()['timezone_default'] ?? 'UTC+3', $timezone);
                                $timezone = $timezone[1][0];
                                ?>
                                <?php foreach ($imports as $import) : ?>
                                    <?php
                                    foreach ($import->jrnl as $jrnl) {
                                        // Перебор записей в журнале

                                        if ($jrnl['action'] === 'create') {
                                            // Найдена дата создания

                                            // Инициализация даты
                                            $create = (new DateTime())->setTimestamp($jrnl['date'])->setTimezone(new DateTimeZone($timezone))->format('H:i d.m.Y') ?? 'Неизвестно';

                                            break;
                                        }
                                    }

                                    foreach ($import->jrnl as $jrnl) {
                                        // Перебор записей в журнале

                                        if ($jrnl['action'] === 'connect_with_account') {
                                            // Найдена дата создания

                                            // Инициализация даты
                                            $account = $jrnl['data']['target'];

                                            break;
                                        }
                                    }
                                    ?>

                                    <div class="mb-3 row">
                                        <div class="col-auto"><?= ++$amount ?>.</div>
                                        <div class="col">
                                            <?= $import->name ?? 'Без названия' ?>
                                        </div>
                                        <div class="col-3 px-0 text-right">
                                            <?= $create ?? 'Неизвестно' ?>
                                        </div>
                                        <a class="pr-0 my-auto col-auto fas fa-user text-dark" href="<?= $date_connect_with_account ?? 'Неизвестно' ?>"></a>
                                        <a class="pr-0 my-auto col-auto fas fa-file-download text-dark" type="button" onclick="page_profile_supplies_download()"></a>
                                        <a class="my-auto col-auto fas fa-trash-alt text-dark" type="button" onclick="page_profile_supplies_delete()"></a>
                                    </div>

                                    <?php if ($amount < count($imports)) : ?>
                                        <div class="dropdown-divider mb-3"></div>
                                    <?php endif ?>
                                <?php endforeach ?>
                            <?php else : ?>
                                <?php
                                // Инициализация складов
                                $warehouses = Warehouse::initWithWrite();

                                // Инициализация итератора
                                $amount_warehouses = 0;
                                ?>
                                <?php foreach ($warehouses as $warehouse) : ?>
                                    <section class="col<?= ++$amount_warehouses <= count($warehouses) ? ' mb-4' : '' ?>">
                                        <h5 class="d-flex"><?= $warehouse->name ?? 'Без названия' ?><small class="ml-auto mt-auto"><a class="text-dark fas fa-pen" type="button" onclick="edit_zaloopa"></a></small></h5>

                                        <?php $form = ActiveForm::begin([
                                            'id' => 'form_warehouse_settings',
                                            'action' => false,
                                            'fieldConfig' => [
                                                'template' => '{label}{input}',
                                            ],
                                            'options' => [
                                                'onsubmit' => 'return false;'
                                            ]
                                        ]);

                                        $list = $warehouse->genListTerminalsFrom();
                                        ?>

                                        <?= $form->field($warehouse, 'trmn', ['options' => ['class' => "mb-3"]])
                                            ->dropDownList($list, [
                                                'onChange' => 'page_profile_settings(this.parentElement.parentElement, \'profile_panel_settings_company\')',
                                                'disabled' => count($list) <= 1
                                            ])->label(false); ?>

                                        <?php ActiveForm::end(); ?>

                                        <?php
                                        // Инициализация номера инстанции импорта
                                        $amount_imports = 0;
                                        ?>

                                        <?php foreach (Import::searchByWarehouse($warehouse) as $import) : ?>
                                            <div class="mx-2 mb-3 row">
                                                <div class="col-auto"><?= ++$amount_imports ?>.</div>
                                                <div class="col">
                                                    <?= $import[0]->name ?? 'Без названия' ?>
                                                </div>
                                                <a class="pr-0 my-auto col-auto fas fa-file-download text-dark" type="button" aria-hidden="true" onclick="page_profile_supplies_download()"></a>
                                                <a class="my-auto col-auto fas fa-trash-alt text-dark" type="button" aria-hidden="true" onclick="page_profile_supplies_delete()"></a>
                                            </div>
                                        <?php endforeach ?>

                                        <?php
                                        $form = ActiveForm::begin([
                                            'id' => 'form_warehouse_supplies',
                                            'action' => false,
                                            'fieldConfig' => [
                                                'template' => '{label}{input}',
                                                'options' => ['class' => '']
                                            ],
                                            'options' => [
                                                'class' => 'px-3 mb-3',
                                                'onsubmit' => 'return false;'
                                            ]
                                        ]);
                                        ?>

                                        <div class="mb-3 row">
                                            <?= $form->field($supply, 'file_excel', ['enableLabel' => false])->fileInput(['multiple' => true, 'onChange' => 'page_profile_supplies_import_excel(this.parentElement.parentElement.parentElement, ' . $warehouse->_key . ', undefined, \'profile_panel_supplies_input_import\')']) ?>
                                        </div>

                                        <?= $form->errorSummary($supply, ['header' => 'В документе были допущены ошибки:' /*, 'footer' => 'Исправьте их и попробуйте снова'*/]); ?>

                                        <?php ActiveForm::end(); ?>
                                    </section>

                                    <?php if ($amount_warehouses < count($warehouses)) : ?>
                                        <div class="dropdown-divider mx-3 mb-4"></div>
                                    <?php endif ?>
                                <?php endforeach ?>
                            <?php endif ?>
                        </div>
                    </div>
                </div>
        </article>
    </div>
</div>

<script src="/js/profile.js" defer></script>
<?php if (
    !yii::$app->user->isGuest
    && (yii::$app->user->identity->type === 'administrator'
        || yii::$app->user->identity->type === 'moderator')
) : ?>
    <script src="/js/profile_panel.js" defer></script>
<?php endif ?>
